var ULBA = ULBA || {};

ULBA.API = ULBA.API || {};

ULBA.API.URL = 'http://www.findaport.com/api/';
//ULBA.API.KEY = '';
ULBA.API.$eventTarget = $('<div></div>');
ULBA.API.TIME_OUT = 15; //seconds

ULBA.API.searchPort = function(params, callback){
    var request = ULBA.API.URL + 'ports/search.json';

    //Delete empty fields
    for(var i=0;i < params.length; i++){
        params[i].value = $.trim(params[i].value);
        if(params[i].value==''){
            params.splice(i,1);
            i--;
        }
    }

    request += '?' + $.param(params, true);

    ULBA.API.sendRequest(request, callback);
};

ULBA.API.getPortBrief = function(portId, callback){
    var request = ULBA.API.URL  + 'port/' + portId + '.json';

    ULBA.API.sendRequest(request, callback);
};

ULBA.API.getPortSummary = function(portId, callback){
    var request = ULBA.API.URL  + 'port/' + portId + '/summary.xml';

    ULBA.API.sendRequest(request, callback, 'html');
};

ULBA.API.getPortDetails = function(portId, callback){
    var request = ULBA.API.URL  + 'port/' + portId + '/info.html';

    ULBA.API.sendRequest(request, callback, 'html');
};

ULBA.API.getPortACEReports = function(portId, callback){
    var request =  ULBA.API.URL + 'port/' + portId +  '/ace_reports.json';

    ULBA.API.sendRequest(request, callback);
};

ULBA.API.getACEReport = function(ace_id, callback){
    var request = ULBA.API.URL  + 'ace_report/' + ace_id + '.json';

    ULBA.API.sendRequest(request, callback);
};

ULBA.API.getPortPlans = function(portId, callback){
    var request = ULBA.API.URL  + 'ports/' + portId + '/plans.json';

    ULBA.API.sendRequest(request, callback);
};

ULBA.API.getCountryInfo = function(locode, callback){
    var request = ULBA.API.URL  + 'countries/' + locode + '.html';

    ULBA.API.sendRequest(request, callback, 'html');
};

ULBA.API.getCountryPorts = function(locode, callback){
    var request = ULBA.API.URL + 'countries/' + locode + '/ports.json';

    ULBA.API.sendRequest(request, callback);
};

ULBA.API.getWeather = function(wx_id, callback){
    var request = ULBA.API.URL + 'weather/' + wx_id + '.json';

    ULBA.API.sendRequest(request, callback);
};

ULBA.API.sendRequest = (function(){
    var callsCounter = 0,
        requestsTimer, ON_REQUESTS_END_DELAY = 300,
        requestTimeOutTimer;

    var countdownCall = function(){
        callsCounter -= 1;

        if(callsCounter <= 0){
            requestsTimer = window.setTimeout(function(){
                ULBA.API.$eventTarget.trigger('onRequestsEnd');
                window.clearTimeout(requestTimeOutTimer);
                callsCounter = 0;
            }, ON_REQUESTS_END_DELAY);
        }

    };

    var addCall = function(){
        callsCounter += 1;
        window.clearTimeout(requestsTimer);

        if(callsCounter == 1){
            ULBA.API.$eventTarget.trigger('onRequestsStart');
        }

        window.clearTimeout(requestTimeOutTimer);
        requestTimeOutTimer = window.setTimeout(function(){
            ULBA.API.$eventTarget.trigger('onRequestTimeOut');
            callsCounter = 0;
        }, ULBA.API.TIME_OUT * 1000)
    };

    var getFreeCallbackName = function(){
        var nameOfCallBackFunction = '',
        counter = 0;

        while(nameOfCallBackFunction == ''){
            if(!ULBA.API['callback_' + counter]){
                nameOfCallBackFunction = 'callback_' + counter;
            }
            counter += 1;
        }

        return nameOfCallBackFunction;
    };

    return function (url, success, dataType){
        var nameOfCallBackFunction = getFreeCallbackName();

//        if(!ULBA.API.KEY)throw 'API KEY IS REQUIRED';

        if(!dataType) dataType = 'jsonp';

        ULBA.API[nameOfCallBackFunction] = function(data){
            delete ULBA.API[nameOfCallBackFunction];
            ULBA.API.$eventTarget.trigger('onRequestSuccess');
            countdownCall();
            success && success(data, url);
        };

        if(url.indexOf('?') == -1){
            url += '?key=' + ULBA.API.KEY;
        }else{
            url += '&key=' + ULBA.API.KEY;
        }

        addCall();

        ULBA.API.$eventTarget.trigger('onRequestSend');

        $.ajax({
            url: url,
            crossDomain: true,
            jsonpCallback: 'ULBA.API.' + nameOfCallBackFunction,
            dataType: dataType,
            success:ULBA.API[nameOfCallBackFunction],
            error : function(XMLHttpRequest, textStatus, errorThrown){
                countdownCall();
                ULBA.API.$eventTarget.trigger('onRequestError', [XMLHttpRequest, textStatus, errorThrown]);
            }
        });
    }
})();

