var ULBA = ULBA || {};

ULBA.common = ULBA.common || {};

ULBA.common.daysOfWeek = ['Sunday','Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];


$(function(){
    $('FORM[name=simpleSearch]').unbind('submit').submit(function(event){
        event.preventDefault();
        
        var params = $(this).serializeArray();
        ULBA.API.searchPort(params, function(data, url){

            ULBA.pageController.loadPage('search-result', {result : data, search : params, request: url});
        });
    });

    $('FORM[name=simpleSearch] DIV.button').unbind('click').click(function(){
        $(this).parents('FORM').submit();
    });

    $('A[title=Support]').unbind('click').click(function(){
        ULBA.pageController.loadPage('support')
    });

    ULBA.API.$eventTarget.bind('onRequestsStart', function(){
        $.loader.show();
    });

    ULBA.API.$eventTarget.bind('onRequestsEnd', function(){
        $.loader.hide();
    });

    ULBA.API.$eventTarget.bind('onRequestTimeOut', function(){
        $.loader.hide();
        $.showAlert('<p><strong>Something went wrong :(<br/>Request timed out</strong></p><p>Please reload page and try again.</p>', 3000);
    });

    ULBA.API.$eventTarget.bind('onRequestError', function(event, XMLHttpRequest, textStatus, errorThrown){
        $.showAlert('<p><strong>' + XMLHttpRequest.statusText +  '</strong></p><p>' + XMLHttpRequest.responseText + '</p>', 3000);
    });

});

function initButtons(){
    $('DIV.button').mousedown(function(){
        $(this).addClass('pressed');
    });

    $('DIV.button').mouseup(function(){
        $(this).removeClass('pressed');
    }).mouseout(function(){
         $(this).removeClass('pressed');
    });
}

function initInputs(){
    $('INPUT[placeholder]').focus(function(){
        var $this = $(this);

        if($this.val() == ''){
            $this.addClass('focus');
        }
    }).blur(function(){
        var $this = $(this);

        if($this.val() == ''){
            $this.removeClass('focus');
        }
    }).change(function(){
        var $this = $(this);

        if($this.val() != ''){
            $this.addClass('focus');
        }else{
            $this.removeClass('focus');
        }
    });

    if($.browser.msie || $.browser.mozilla){
        $('INPUT[placeholder]').each(function(){
            var $this = $(this), marginTop = $this.css('margin-top'), marginLeft = $this.css('margin-left');

            $this.before('<br class="ie7only"/><span style="margin-top:' + marginTop + '; margin-left:' + marginLeft + '" class="helpText">' + $this.attr('placeholder') + '</span>')
            .prev('SPAN').click(function(){$this.trigger('focus')});

            if($this.val() != ''){
                $this.addClass('focus');
            }
        })
    }
}

function getGoodXML(xml){
    var xmlDoc;
    if (window.DOMParser){
        parser=new DOMParser();
        xmlDoc=parser.parseFromString(xml,"text/xml");
    }else { // Internet Explorer
        xmlDoc=new ActiveXObject("Microsoft.XMLDOM");
        xmlDoc.async="false";
        xmlDoc.loadXML(xml);
    }

    return xmlDoc;
}


function getRandomInt(min, max){
    return Math.floor(Math.random() * (max - min + 1)) + min;
}

function getPortSummary(portId){
    ULBA.API.getPortBrief(portId, function(data, status, url) {
        ULBA.pageController.loadPage('port-details', {result : data, request:url });
    });
}

function getCountryInfo(locode){
    ULBA.API.getCountryInfo(locode, function(data, status, url) {
        ULBA.pageController.loadPage('country-details', {result : data, locode : locode, request: url});
    });
}



