function JSON2KML(placemarks, generateDescription){

    var KML = getGoodXML('<kml xmlns="http://earth.google.com/kml/2.1"></kml>'),
        Document = KML.createElement('Document');

    if(placemarks.constructor != Array)placemarks=[placemarks];
    
    for(var i = placemarks.length-1; i >= 0; i--){

        var preparedPlacemark = preparePlacemark(placemarks[i]);

        var Style = buildStyleNode(preparedPlacemark);
        var Placemark = buildPlacemarkNode(preparedPlacemark);

        Document.appendChild(Style);
        Document.appendChild(Placemark);

    }

    function preparePlacemark(placemark){
        //symbol_id should consists of 3 symbols
        var symbol_idLenght = placemark.symbol_id.toString().length;
        for(var j = 3 - symbol_idLenght; j > 0; j--){
            placemark.symbol_id = '0' + placemark.symbol_id;
        }

        placemark.description = placemark.description || (generateDescription && generateDescription(placemark)) || '';
        if(placemark.description && placemark.description.constructor != String)placemark.description='Desciption has mistaken type. Should be String';

        return placemark;
    }

    function buildStyleNode(placemark){
        var symbolId = placemark.symbol_id;

        var Style = KML.createElement('Style'),
            IconStyle = KML.createElement('IconStyle'),
            Icon = KML.createElement('Icon'),
            href = KML.createElement('href');


        $(Style).attr('id', 'symbol' + symbolId);
        $(href).text(ULBA.config.SymbolURL + symbolId + '.png');

        Icon.appendChild(href);
        IconStyle.appendChild(Icon);
        Style.appendChild(IconStyle);

        return Style
    }

    function buildPlacemarkNode (placemark){
        var lat = placemark.lat,
            lng = placemark.lng,
            portName = placemark.port,
            id = placemark.piuid,
            locode = placemark.locode,
            symbolId = placemark.symbol_id,
            country = countries[locode.toLowerCase()],
            portDescription = placemark.description;

        var Placemark = KML.createElement('Placemark'),
            name = KML.createElement('name'),
            description = KML.createElement('description'),
            styleUrl = KML.createElement('styleUrl'),
            Point = KML.createElement('Point'),
            altitudeMode = KML.createElement('altitudeMode'),
            coordinates = KML.createElement('coordinates');

        $(Placemark).attr('id', id);
        $(name).text(portName + ', ' + country);
        if(portDescription)$(description).text(portDescription);
        $(styleUrl).text('#symbol' + symbolId);
        $(altitudeMode).text('relativeToGround');
        $(coordinates).text(lng + ',' + lat);

        Point.appendChild(altitudeMode);
        Point.appendChild(coordinates);

        Placemark.appendChild(name);
        if(portDescription)Placemark.appendChild(description);
        Placemark.appendChild(styleUrl);
        Placemark.appendChild(Point);

        return Placemark;
    }

    if(!Document.xml){
        if(XMLSerializer){
            Document.xml = new XMLSerializer().serializeToString(Document)
        }
    }

    var resultKML = getGoodXML('<kml xmlns="http://earth.google.com/kml/2.1">' + Document.xml + '</kml>');

    if(!resultKML.xml){
        if(XMLSerializer){
            resultKML.xml = new XMLSerializer().serializeToString(resultKML)
        }
    }

    return resultKML.xml;
}