/**
* (c) 2008, Ilya Kantor
* localStorage by Koval Nikolay
* 1.1.1
*/
Storage = {
    engines: ["localStorage", "WhatWG", "userData"],
    init: function (onready) {
        for (var i = 0; i < this.engines.length; i++) {
            try {
                this[this.engines[i]](function () { Storage.active = true; onready && onready() });
                break
            } catch (e) {}
        }
    }
};

Storage.localStorage = function (onready) {
    if (!localStorage) throw new Error("Browser doesn't support it");

    Storage = {
        put: function (key, value) {
            localStorage.setItem(key, value);
        },
        get: function (key) {return localStorage.getItem(key);},
        remove: function (key) {localStorage.removeItem(key);},
        getKeys: function () {var list = [];
            for (i in localStorage) list.push(i)
            return list
        },
        clear: function () {
            try {localStorage.clear();}catch(e){}
            for (var i in localStorage) {
            	try {localStorage.removeItem(i);} 
            	catch (e) {} 
            	finally{alert('Storage cleared')}
			}
        }
    };
    onready()
};

Storage.WhatWG = function (onready) {
    var storage = globalStorage[location.hostname];
    Storage = {
        put: function (key, value) {storage[key] = value},
        get: function (key) {return String(storage[key])},
        remove: function (key) {delete storage[key]},
        getKeys: function () {
            var list = [];
            for (i in storage) list.push(i)
            return list
        },

        clear: function () {
            for (i in storage) {
                delete storage[i]
            }
        }
    };

    onready()
};

Storage.userData = function (onready) {
    var namespace = "data";

    if (!document.body.addBehavior) {
        throw new Error("No addBehavior available")
    }

    var storage = document.getElementById('storageElement');
    if (!storage) {
        storage = document.createElement('span');
        document.body.appendChild(storage);
        storage.addBehavior("#default#userData");
        // initial element load
        storage.load(namespace)
    }

    Storage = {
        put: function (key, value) {
            storage.setAttribute(key, value);
            storage.save(namespace)
        },

        get: function (key) {
            return storage.getAttribute(key)
        },

        remove: function (key) {
            storage.removeAttribute(key);
            storage.save(namespace)
        },

        getKeys: function () {
            var list = [];
            var attrs = storage.XMLDocument.documentElement.attributes;

            for (var i = 0; i < attrs.length; i++) {
                list.push(attrs[i].name)
            }

            return list
        },

        clear: function () {
            var attrs = storage.XMLDocument.documentElement.attributes;

            for (var i = 0; i < attrs.length; i++) {
                storage.removeAttribute(attrs[i].name)
            }
            storage.save(namespace)
        }
    };

    onready()

};

