function initCurrentPage(extraData){
    var smallMap;

    var currentPage = ULBA.pageController.currentPage;

    currentPage.restoreState = function(extraData){
        $('#content').empty().append(currentPage.cachedState);
        
        if(extraData.result){
            //Reset page's state to initial and fill content
            $('#content').empty().append(currentPage.originalHTML);
            showContent(extraData)
        }
    };

    function showContent(summary){
        extraData = summary || extraData;
        var content, detailsDIV;

        content = extraData.result;
        detailsDIV = $('DIV.country-details').find('DIV.details').get(0);

        detailsDIV.innerHTML = content;

        $(detailsDIV).find('A[href^="#"]').click(function(event){

            event.preventDefault();
            var catName = $(this).attr('href').replace(/.*#/i, ''), offsetTop;
            var $targetLink = $('A[name="' + catName + '"]');
            if($targetLink.size()>0){
                offsetTop = $targetLink.get(0).offsetTop;

                $('BODY').get(0).scrollTop = offsetTop;
                $('HTML').get(0).scrollTop = offsetTop;
            }
        });

        var $h1 = $('DIV.country-details').find('DIV.details').find(' > H1');
        $('DIV.breadcrumbs').find('SPAN').text($h1.text());
        $h1.remove();

        $('DIV.country-details').find('DIV.details').prepend('<div id="countryPorts" class="countryPorts googlemap"></div>');

        ULBA.API.getCountryPorts(extraData.locode, function(data){
            var KML = JSON2KML(data, function(port){
                var country = countries[port.locode.toLowerCase()],
                    portName = port.port;

                var description = '<A onclick="getPortSummary(\'' + port.piuid + '\')" class="uglyInfoBoxSolution" href="index.html#page=country-details" title="View Port information">' + portName + '</A>, '
                + '<A onclick="getCountryInfo(\'' + port.locode.toLowerCase() +'\')" href="index.html#page=country-details" locode="' + port.locode.toLowerCase() + '"  title="View Country information">' + country + '</A>';

                return description
            });

            var countryMap=new GMap2(document.getElementById("countryPorts"));
            countryMap.setCenter(new GLatLng(0,0),1);
            countryMap.addControl(new GSmallMapControl());
            var mgr = new MarkerManager(countryMap);
            mgr.clearMarkers();
            countryPorts = new EGeoXml("countryPorts", countryMap, KML, {addmarker:addMark});
            countryPorts.parse();

            var zoomLevel = countryMap.getBoundsZoomLevel(countryPorts.bounds);
            if(zoomLevel>15)zoomLevel=15;

            countryMap.setCenter(countryPorts.bounds.getCenter(),zoomLevel);


            function addMark(marker,name,desc,imagefile,n) {
                var latLng = marker.getLatLng(), correctedMarker,
                    icon = new GIcon({image: imagefile, iconAnchor: new GPoint(16,16), iconSize: new GSize(32, 32), infoWindowAnchor: new GPoint(16,16)});

                correctedMarker = new GMarker(latLng, icon);
                GEvent.addListener(correctedMarker, 'click', function(){
                    correctedMarker.openInfoWindowHtml(desc, {});
                });
                mgr.addMarker(correctedMarker,0);
            }

        });
    }

    $(function(){
        $('DIV.breadcrumbs').find('A[title="Search Result"]').click(function(event){
            ULBA.pageController.loadPage('search-result');
            return false;
        }).end()
        .find('A[title=Search]').click(function(event){
            ULBA.pageController.loadPage('search');
            return false;
        });
        showContent(extraData)
    });
}