function initCurrentPage(extraData){
    var fullMap;

    var currentPage = ULBA.pageController.currentPage;

    currentPage.restoreState = function(extraData){
        $('#content').empty().append(currentPage.cachedState);
        
        if(extraData.result){
            //Reset page's state to initial and fill content
            $('#content').empty().append(currentPage.originalHTML);
            showContent(extraData)
        }
    };

    function showContent(summary){
        extraData = summary || extraData;

        var port = extraData.result,
            portName = port.port;

        var portCoordinates = new GLatLng(port.lat,port.lng);

        $('DIV.breadcrumbs').find('A.portName').text(portName).attr('title',portName).attr('href','index.html#page=port-details').unbind('click').click(function(event){
            event.preventDefault();
            ULBA.pageController.loadPage('port-details');
        });

        $('DIV.maps-plans').html(extraData.html).find('A').each(function(){
            $(this).attr('href',ULBA.pageController.location + '&target=' + $(this).attr('data-target') || '');    
        })
        .click(function(event){
            event.preventDefault();
            $('DIV.maps-plans A.selected').removeClass('selected');
            $(event.target).addClass('selected');

            $('DIV.breadcrumbs').find('SPAN').text($(event.target).text());
        }).end()
        .find('A.showMap').addClass('nobg').text('View Full Map').click(function(event){
            var KML = JSON2KML(port);

            $('DIV.details').html('<div class="fullMap" id="fullMap"></div>');
            fullMap=new GMap2(document.getElementById("fullMap"));
            fullMap.setCenter(portCoordinates,10);
            fullMap.setUIToDefault();
            var mgr = new MarkerManager(fullMap);
            mgr.clearMarkers();
            fullMapKML = new EGeoXml("fullMapKML", fullMap, KML, {addmarker:addMark});
            fullMapKML.parse();

            function addMark(marker,name,desc,imagefile,n) {

                var latLng = marker.getLatLng(), correctedMarker,
                    icon = new GIcon({image: imagefile,iconAnchor: new GPoint(16,16), iconSize: new GSize(32, 32), infoWindowAnchor: new GPoint(16,16)});

                correctedMarker = new GMarker(latLng, icon);

                mgr.addMarker(correctedMarker,0);
            }


        }).end()
        .find('DIV.plansAndPhotos').find('A').click(function(event){
             $('DIV.details').html('<img title="' + $(this).text() + '" alt="' + $(this).text() + '" class="plans" src="' + $(this).attr('data-href') + '"/>');
        }).end().end()
        .find('DIV.ACEreports').find('A').click(function(event){
            var ace_id = $(this).attr('data-ace_id');
            currentPage.data.ACEreports  = currentPage.data.ACEreports  || {};

            if(currentPage.data.ACEreports [ace_id]){
                var ACEreports = currentPage.data.ACEreports [ace_id];
                $('DIV.details').empty().append('<h2>' + ACEreports.heading + '</h2><br />').append(ACEreports.report);
            }else{
                ULBA.API.getACEReport(ace_id, function(data){
                    currentPage.data.ACEreports[ace_id] = data;
                    $('DIV.details').empty().append('<h2>' + data.heading + '</h2><br />').append(data.report);
                });
            }

        });

/*        var photos = [];

        $('DIV.maps-plans').find('H2.plans').text('Plans').end()
        .find('DIV.plansAndPhotos').find('A[data-target$=".jpg"]').each(function(){
            var $this = $(this);
            photos.push($this.clone(true));
            $(this).remove();
        }).end()
        
        .after('<h2 class="photos plans">Photos</h2><hr /><div class="photos"><div>');

        if(photos.length==0){
            $('DIV.maps-plans').find('DIV.photos').html('No photos');
        }else{
            $('DIV.maps-plans').find('DIV.photos').empty();
        }

        if($('DIV.plansAndPhotos').find('A').size()==0){
            $('DIV.plansAndPhotos').html('No plans')    
        }

        for(var i = 0; i < photos.length; i++){
            $('DIV.maps-plans').find('DIV.photos').append(photos[i]);    
        }
*/
        $('A.detailedInfo').click(function(event){
            var $self = $(this);
            event.preventDefault();
            var portId = $self.attr('data-port-id');

            ULBA.API.getPortDetails(portId,function(data){
                $('DIV.details').get(0).innerHTML = data;
                $('DIV.details').find('h1').remove();                
            });

        });

        if(extraData.target)$('A[uId="' + extraData.target + '"]').trigger('click');
    }

    $(function(){
        $('DIV.breadcrumbs').find('A[title="Search Result"]').click(function(event){
            ULBA.pageController.loadPage('search-result');
            return false;
        }).end()
        .find('A[title=Search]').click(function(event){
            ULBA.pageController.loadPage('search');
            return false;
        });

        showContent(extraData)
    });
}