function initCurrentPage(extraData){
    var map, currentPage = ULBA.pageController.currentPage;

    currentPage.restoreState = function(generalPageContent){
        $('#content').empty().append(currentPage.cachedState);

        if(generalPageContent.result){
            //Reset page's state to initial and fill content
            $('#content').empty().append(currentPage.originalHTML);
            showContent(generalPageContent);
        }
    };

    function showContent(generalPageContent){
        var portName, simpleFormSearch = {};

        for(var i = 0; i < generalPageContent.search.length; i++){
            simpleFormSearch[generalPageContent.search[i].name] = generalPageContent.search[i].value;
        }

        $('INPUT[name=port]').val(simpleFormSearch['port'] || '');

        if(generalPageContent.result.ports.length > 0){
            processServerFeedback(generalPageContent.result);
        }else if(!extraData || generalPageContent.result.ports.length==0){
            renderNoResultMessage()
        }

        function renderNoResultMessage(){
            $('DIV.paging').hide();
            $('TABLE').hide();
            $('#content').find('DIV.search-result').append('<DIV class="noresult"><br/><br />No ports found.\
                    <br />Do you know of a port matching your search criteria? Then please Request a Port Listing.\
            </DIV>');
        }

        function processServerFeedback(result){
            setUpPaginator(result);

            addPortsIntoTable(result);

            if($('#map:visible').size()==1)showPortsOnMap();

            setUpPageScroll();
            setUpShowMapButton();
        }

        function setUpPageScroll(){
            var clientHeight = $('html').get(0).clientHeight,
                scrollHeight = $('html').get(0).scrollHeight;

            if(scrollHeight > clientHeight){
                $('html').get(0).scrollTop = scrollHeight - clientHeight;  
            }
        }

        function setUpShowMapButton(result){
            $('A.map').toggle(function(event){
                event.preventDefault();

                $('#map').show();
                $(this).text('Hide map').attr('title', 'Hide map').addClass('active');
                $('TABLE').addClass('mapActivated');

                showPortsOnMap();
            }, function(event){
                event.preventDefault();

                $('#map').hide();
                $('TABLE').removeClass('mapActivated');
                $(this).text('Show map').attr('title', 'Show map').removeClass('active');
            });

            if( $('A.map').attr('title')=='Hide map')$('A.map').trigger('click');
        }

        function setUpPaginator(result){

            var currentPage = parseInt(result.page) || 1,
                nextPage = currentPage + 1,
                request = generalPageContent.request,
                showedPorts = parseInt(result.results) * currentPage,
                totalCountOfPorts = result.total_results;

            $('IMG.smallAjaxLoader').hide();

            if(showedPorts >= totalCountOfPorts){
                showedPorts = totalCountOfPorts;
                $('DIV.paging').find('A').hide();
            }else{
                $('DIV.paging').find('A').show()
            }

            $('DIV.paging').find('SPAN').text(showedPorts + ' of ' + totalCountOfPorts).end()
            .find('A').unbind('click').removeClass('disabled').click(function(){
                $(this).addClass('disabled').unbind('click').click(function(){return false;});
                $('IMG.smallAjaxLoader').show();

                var params = {};
                for(var i in generalPageContent.search){
                    params[generalPageContent.search[i].name] = generalPageContent.search[i].value
                }

                params['page'] = nextPage;

                ULBA.API.searchPort(params, function(data, url){
                    generalPageContent.result.page = data.page;

                    for(var i = 0; i < data.ports.length; i++){
                        generalPageContent.result.ports.push(data.ports[i])
                    }

                    ULBA.pageController.pages['search-result'].saveIntoStorage('search-result', JSON.stringify(generalPageContent));

                    processServerFeedback(data);
                });

                return false;
            });
        }

        function addPortsIntoTable(result) {
            var $tbody = $('TBODY');

            $(result.ports).each(function(index, item) {
                var currentPort = item,
                    portName = $.trim(currentPort.port),
                    country = countries[currentPort.locode.toLowerCase()],
                    locode = currentPort.locode, $port;


                $port = $('<a class="port" href="index.html#page=search-result" title="View port info">' + portName + '</a>' +
                    '&nbsp;<span class="iconsBg findPort" title="Show port on map"></span>');


                var $country = $('<a goal="' + country + '" class="country" href="index.html#page=search-result" onclick="return false;" title="View country details">' + country + '</a>');

                var fullName = portName + ', ' + country;
                fullName.replace(/'/g, '');

                var $tr = $('<tr name="' + fullName + '"></tr>');
                $tr.append($('<td></td>').append($port))
                .append($('<td class="countryTD"></td>').append($country))
                .appendTo($tbody)
                .find('A.port').click(function(event) {
                    event.preventDefault();
                    var portId = currentPort.piuid;

                    ULBA.API.getPortBrief(portId, function(data, url) {
                        ULBA.pageController.loadPage('port-details', {result : data, request:url });
                    })
                })
                .attr('portId', currentPort.piuid).end()
                .find('A.country')
                .click(function(event) {
                    event.preventDefault();

                    ULBA.API.getCountryInfo(locode, function(data, url) {
                        ULBA.pageController.loadPage('country-details', {result : data, locode : locode, request: url});
                    });
                })
                .attr('country', country);

            });

            $('TR:even').addClass('even');
        }

        function showPortsOnMap(){
            var KML = JSON2KML(generalPageContent.result.ports, function(port){
                var country = countries[port.locode.toLowerCase()],
                    portName = port.port;

                var description = '<A onclick="getPortSummary(\'' + port.piuid + '\')" class="uglyInfoBoxSolution" href="index.html#page=search-result" title="View Port information">' + portName + '</A>, '
                + '<A onclick="getCountryInfo(\'' + port.locode.toLowerCase() +'\')" href="index.html#page=search-result" title="View Country information">' + country + '</A>';

                return description
            });

            map=new GMap2(document.getElementById("map"));
            map.setCenter(new GLatLng(40,40),2);
            map.addControl(new GSmallMapControl());
            var mgr = new MarkerManager(map);
            mgr.clearMarkers();
            
            exml = new EGeoXml("exml", map, KML, {nozoom:false, addmarker:addMark});
            exml.parse();

            var zoomLevel = map.getBoundsZoomLevel(exml.bounds);
            if(zoomLevel>10)zoomLevel=10;

            map.setCenter(exml.bounds.getCenter(), zoomLevel);

            function addMark(marker,name,desc,imagefile,n) {

                var latLng = marker.getLatLng(), correctedMarker,
                    icon = new GIcon({image: imagefile, iconAnchor: new GPoint(16,16), iconSize: new GSize(32, 32), infoWindowAnchor: new GPoint(16,16)});

                correctedMarker = new GMarker(latLng, icon);
                GEvent.addListener(correctedMarker, 'click', function(){
                    correctedMarker.openInfoWindowHtml(desc, {});
                });
                mgr.addMarker(correctedMarker,0);
                
                name = name.replace(/'/g, '');

                $("TR[name='" + name + "']").find('SPAN.findPort').click(function(event){
                    GEvent.trigger(correctedMarker,'click');

                    return false;
                });
            }
        }
    }

    $(function(){
        $('DIV.breadcrumbs').find('A[title=Search]').click(function(event){
            ULBA.pageController.loadPage('search');

            return false;
        });



        showContent(extraData);
    });
}